## secilc 2.6

=== Makefile ===
PREFIX ?= $(DESTDIR)/usr
BINDIR ?= $(PREFIX)/bin
MANDIR ?= $(PREFIX)/share/man
LIBDIR ?= $(PREFIX)/lib
INCLUDEDIR ?= $(PREFIX)/include

LDLIBS = -lsepol -L$(LIBDIR)
SECILC = secilc
SECILC_SRCS := secilc.c
SECILC_OBJS := $(patsubst %.c,%.o,$(SECILC_SRCS))

# The secilc man page:
MANPAGE = secilc.8
XMLTO = xmlto

CFLAGS ?= -Wall -Wshadow -Wextra -Wundef -Wmissing-format-attribute -Wcast-align -Wstrict-prototypes -Wpointer-arith -Wunused

override CFLAGS += -I$(INCLUDEDIR) -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64

all: $(SECILC) man

$(SECILC): $(SECILC_OBJS)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS) $(LDLIBS)

test: $(SECILC)
	./$(SECILC) test/policy.cil

man: $(MANPAGE).xml
	$(XMLTO) man $(MANPAGE).xml

install: all man
	-mkdir -p $(BINDIR)
	-mkdir -p $(MANDIR)/man8
	install -m 755 $(SECILC) $(BINDIR)
	install -m 644 $(MANPAGE) $(MANDIR)/man8

doc:
	$(MAKE) -C docs

clean:
	rm -f $(SECILC)
	rm -f $(SECILC_OBJS)
	rm -f policy.*
	rm -f file_contexts
	rm -f $(MANPAGE)

relabel:

.PHONY: all clean test install doc relabel man

=== docs/Makefile ===
CWD ?= $(shell pwd)
HTMLDIR ?= $(CWD)/html
PDFDIR ?= $(CWD)/pdf
TMPDIR ?= $(CWD)/tmp
TESTDIR ?= $(CWD)/../test

# All the markdown files that make up the guide:
FILE_LIST ?= cil_introduction.md \
	cil_reference_guide.md \
	cil_access_vector_rules.md \
	cil_call_macro_statements.md \
	cil_class_and_permission_statements.md \
	cil_conditional_statements.md \
	cil_constraint_statements.md \
	cil_container_statements.md \
	cil_context_statement.md \
	cil_default_object_statements.md \
	cil_file_labeling_statements.md \
	cil_mls_labeling_statements.md \
	cil_network_labeling_statements.md \
	cil_policy_config_statements.md \
	cil_role_statements.md \
	cil_sid_statements.md \
	cil_type_statements.md \
	cil_user_statements.md \
	cil_xen_statements.md

PANDOC_FILE_LIST = $(addprefix $(TMPDIR)/,$(FILE_LIST))

PDF_OUT=CIL_Reference_Guide.pdf
HTML_OUT=CIL_Reference_Guide.html
PANDOC = pandoc

all: html pdf

$(TMPDIR):
	mkdir -p $(TMPDIR)

$(TMPDIR)/%.md: %.md | $(TMPDIR)
	cp -f $< $(TMPDIR)/
	@# Substitute markdown links for conversion into PDF links
	sed -i -re 's:(\[`[^`]*`\])\([^#]*([^\)]):\1\(\2:g' $@

$(TMPDIR)/policy.cil: $(TESTDIR)/policy.cil
	cp -f $< $@
	@# add a title for the TOC to policy.cil. This is needed to play nicely with the PDF conversion.
	sed -i '1i Example Policy\n=========\n```' $@
	echo '```' >> $@

html: $(PANDOC_FILE_LIST) $(TMPDIR)/policy.cil
	mkdir -p $(HTMLDIR)
	$(PANDOC) -t html $^ -o $(HTMLDIR)/$(HTML_OUT)

pdf: $(PANDOC_FILE_LIST) $(TMPDIR)/policy.cil
	mkdir -p $(PDFDIR)
	$(PANDOC) --standalone --toc $^ -o $(PDFDIR)/$(PDF_OUT)

clean:
	rm -rf $(HTMLDIR)
	rm -rf $(PDFDIR)
	rm -rf $(TMPDIR)

## secilc 2.5

=== debian/changelog ===
secilc (2.5-1) unstable; urgency=medium

  * Initial version. (Closes: #747668)

 -- Laurent Bigonville <bigon@debian.org>  Mon, 25 Apr 2016 22:03:41 +0200

=== debian/control ===
Source: secilc
VCS-Git: https://anonscm.debian.org/git/selinux/secilc.git
VCS-Browser: https://anonscm.debian.org/gitweb/?p=selinux/secilc.git;a=summary
Priority: optional
Section: utils
Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
Uploaders: Laurent Bigonville <bigon@debian.org>
Standards-Version: 3.9.8
Build-Depends: debhelper (>= 9), libsepol1-dev (>= 2.5), xmlto
Build-Depends-Indep: lmodern,
                     pandoc,
                     texlive-fonts-recommended,
                     texlive-latex-recommended
Homepage: https://github.com/SELinuxProject/selinux/wiki

Package: secilc
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: SELinux CIL compiler
 Security-enhanced Linux is a patch of the Linux® kernel and a number
 of utilities with enhanced security functionality designed to add
 mandatory access controls to Linux. The Security-enhanced Linux
 kernel contains new architectural components originally developed to
 improve the security of the Flask operating system. These
 architectural components provide general support for the enforcement
 of many kinds of mandatory access control policies, including those
 based on the concepts of Type Enforcement®, Role-based Access
 Control, and Multi-level Security.
 .
 The SELinux CIL Compiler is a compiler that converts the CIL language as
 described on the CIL design wiki into a kernel binary policy file.

Package: secilc-doc
Architecture: all
Depends: ${misc:Depends}
Section: doc
Description: documentation for the SELinux CIL Compiler
 Security-enhanced Linux is a patch of the Linux® kernel and a number
 of utilities with enhanced security functionality designed to add
 mandatory access controls to Linux. The Security-enhanced Linux
 kernel contains new architectural components originally developed to
 improve the security of the Flask operating system. These
 architectural components provide general support for the enforcement
 of many kinds of mandatory access control policies, including those
 based on the concepts of Type Enforcement®, Role-based Access
 Control, and Multi-level Security.
 .
 The SELinux CIL Compiler is a compiler that converts the CIL language as
 described on the CIL design wiki into a kernel binary policy file.
 .
 This package contains the documentation.

## secilc 2.6

=== debian/changelog ===
secilc (2.6-1) unstable; urgency=medium

  * New upstream release
    - Bump libsepol1-dev build-dependency to >= 2.6 to match the release

 -- Laurent Bigonville <bigon@debian.org>  Fri, 28 Oct 2016 11:09:14 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
 Uploaders: Laurent Bigonville <bigon@debian.org>
 Standards-Version: 3.9.8
-Build-Depends: debhelper (>= 9), libsepol1-dev (>= 2.5), xmlto
+Build-Depends: debhelper (>= 9), libsepol1-dev (>= 2.6), xmlto
 Build-Depends-Indep: lmodern,
                      pandoc,
                      texlive-fonts-recommended,

=== debian/watch ===
version=3

https://github.com/SELinuxProject/selinux/wiki/Releases (?:.*)/releases/(?:\d*)/secilc-([\d\.]*)\.tar\.gz

## secilc 2.7

=== Makefile ===
PREFIX ?= $(DESTDIR)/usr
BINDIR ?= $(PREFIX)/bin
MANDIR ?= $(PREFIX)/share/man
LIBDIR ?= $(PREFIX)/lib
INCLUDEDIR ?= $(PREFIX)/include

SECILC = secilc
SECILC_SRCS := secilc.c
SECILC_OBJS := $(patsubst %.c,%.o,$(SECILC_SRCS))

SECIL2CONF = secil2conf
SECIL2CONF_SRCS := secil2conf.c
SECIL2CONF_OBJS := $(patsubst %.c,%.o,$(SECIL2CONF_SRCS))

SECILC_MANPAGE = secilc.8
SECIL2CONF_MANPAGE = secil2conf.8
XMLTO = xmlto

CFLAGS ?= -Wall -Wshadow -Wextra -Wundef -Wmissing-format-attribute -Wcast-align -Wstrict-prototypes -Wpointer-arith -Wunused

override CFLAGS += -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64
override LDLIBS += -lsepol

all: $(SECILC) $(SECIL2CONF) man

$(SECILC): $(SECILC_OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)

test: $(SECILC)
	./$(SECILC) test/policy.cil

$(SECIL2CONF): $(SECIL2CONF_OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)

man: $(SECILC_MANPAGE) $(SECIL2CONF_MANPAGE)

$(SECILC_MANPAGE): $(SECILC_MANPAGE).xml
	$(XMLTO) man $(SECILC_MANPAGE).xml

$(SECIL2CONF_MANPAGE): $(SECIL2CONF_MANPAGE).xml
	$(XMLTO) man $(SECIL2CONF_MANPAGE).xml

install: all man
	-mkdir -p $(BINDIR)
	-mkdir -p $(MANDIR)/man8
	install -m 755 $(SECILC) $(BINDIR)
	install -m 755 $(SECIL2CONF) $(BINDIR)
	install -m 644 $(SECILC_MANPAGE) $(MANDIR)/man8
	install -m 644 $(SECIL2CONF_MANPAGE) $(MANDIR)/man8

doc:
	$(MAKE) -C docs

clean:
	rm -f $(SECILC)
	rm -f $(SECILC_OBJS)
	rm -f $(SECIL2CONF)
	rm -f $(SECIL2CONF_OBJS)
	rm -f policy.*
	rm -f file_contexts
	rm -f $(SECILC_MANPAGE)
	rm -f $(SECIL2CONF_MANPAGE)

relabel:

.PHONY: all clean test install doc relabel man

=== docs/Makefile ===
--- 
+++ 
@@ -23,6 +23,7 @@
 	cil_sid_statements.md \
 	cil_type_statements.md \
 	cil_user_statements.md \
+	cil_infiniband_statements.md \
 	cil_xen_statements.md
 
 PANDOC_FILE_LIST = $(addprefix $(TMPDIR)/,$(FILE_LIST))

=== debian/changelog ===
secilc (2.7-1) unstable; urgency=medium

  * New upstream release
    - Bump libsepol1-dev build-dependency to >= 2.7 to match the release
  * Bump debhelper compatibility to 10
  * Bump Standards-Version to 4.1.0 (no further changes)

 -- Laurent Bigonville <bigon@debian.org>  Sun, 10 Sep 2017 00:32:32 +0200

secilc (2.7~rc2-1) experimental; urgency=medium

  * New upstream release candidate
    - Bump libsepol1-dev build-dependency to >= 2.7~ to match the release
  * debian/watch: Add support for rc releases and use macros
  * debian/control: Bump Standards-Version to 4.0.0 (no further changes)

 -- Laurent Bigonville <bigon@debian.org>  Wed, 21 Jun 2017 20:06:28 +0200

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 Section: utils
 Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
 Uploaders: Laurent Bigonville <bigon@debian.org>
-Standards-Version: 3.9.8
-Build-Depends: debhelper (>= 9), libsepol1-dev (>= 2.6), xmlto
+Standards-Version: 4.1.0
+Build-Depends: debhelper (>= 10), libsepol1-dev (>= 2.7), xmlto
 Build-Depends-Indep: lmodern,
                      pandoc,
                      texlive-fonts-recommended,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# The build system doesn't use CPPFLAGS, pass them to CFLAGS to enable the
# missing (hardening) flags.
export DEB_CFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)

%:
	dh $@

override_dh_auto_build-arch:
	LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) dh_auto_build

override_dh_auto_build-indep:
	$(MAKE) doc

## secilc 2.8

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,6 @@
-PREFIX ?= $(DESTDIR)/usr
+PREFIX ?= /usr
 BINDIR ?= $(PREFIX)/bin
 MANDIR ?= $(PREFIX)/share/man
-LIBDIR ?= $(PREFIX)/lib
-INCLUDEDIR ?= $(PREFIX)/include
 
 SECILC = secilc
 SECILC_SRCS := secilc.c
@@ -41,12 +39,12 @@
 	$(XMLTO) man $(SECIL2CONF_MANPAGE).xml
 
 install: all man
-	-mkdir -p $(BINDIR)
-	-mkdir -p $(MANDIR)/man8
-	install -m 755 $(SECILC) $(BINDIR)
-	install -m 755 $(SECIL2CONF) $(BINDIR)
-	install -m 644 $(SECILC_MANPAGE) $(MANDIR)/man8
-	install -m 644 $(SECIL2CONF_MANPAGE) $(MANDIR)/man8
+	-mkdir -p $(DESTDIR)$(BINDIR)
+	-mkdir -p $(DESTDIR)$(MANDIR)/man8
+	install -m 755 $(SECILC) $(DESTDIR)$(BINDIR)
+	install -m 755 $(SECIL2CONF) $(DESTDIR)$(BINDIR)
+	install -m 644 $(SECILC_MANPAGE) $(DESTDIR)$(MANDIR)/man8
+	install -m 644 $(SECIL2CONF_MANPAGE) $(DESTDIR)$(MANDIR)/man8
 
 doc:
 	$(MAKE) -C docs

=== debian/changelog ===
secilc (2.8-1) unstable; urgency=medium

  * New upstream release
    - Bump libsepol1-dev build-dependency to >= 2.8 to match the release
  * debian/control: Point Vcs-* fields to new (salsa) machine
  * debian/rules: Adjust to match upstream changes to the build system
  * debian/control: Bump Standards-Version to 4.1.4 (no further changes)

 -- Laurent Bigonville <bigon@debian.org>  Mon, 28 May 2018 16:09:07 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: secilc
-VCS-Git: https://anonscm.debian.org/git/selinux/secilc.git
-VCS-Browser: https://anonscm.debian.org/gitweb/?p=selinux/secilc.git;a=summary
+VCS-Git: https://salsa.debian.org/selinux-team/secilc.git
+VCS-Browser: https://salsa.debian.org/selinux-team/secilc
 Priority: optional
 Section: utils
 Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
 Uploaders: Laurent Bigonville <bigon@debian.org>
-Standards-Version: 4.1.0
-Build-Depends: debhelper (>= 10), libsepol1-dev (>= 2.7), xmlto
+Standards-Version: 4.1.4
+Build-Depends: debhelper (>= 10), libsepol1-dev (>= 2.8), xmlto
 Build-Depends-Indep: lmodern,
                      pandoc,
                      texlive-fonts-recommended,

=== debian/rules ===
--- 
+++ 
@@ -13,8 +13,5 @@
 %:
 	dh $@
 
-override_dh_auto_build-arch:
-	LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) dh_auto_build
-
 override_dh_auto_build-indep:
 	$(MAKE) doc

## secilc 2.9

=== debian/changelog ===
secilc (2.9-2) unstable; urgency=medium

  * Upload to unstable

 -- Laurent Bigonville <bigon@debian.org>  Mon, 08 Jul 2019 09:26:27 +0200

secilc (2.9-1) experimental; urgency=medium

  * New upstream release
    - Bump libsepol1-dev build-dependency to >= 2.9 to match the release
    - Fix the ability to build the package twice (Closes: #899083)
  * debian/control: Bump Standards-Version to 4.3.0 (no further changes)
  * debian/watch: Adjust the URL

 -- Laurent Bigonville <bigon@debian.org>  Sun, 17 Mar 2019 21:11:23 +0100

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 Section: utils
 Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
 Uploaders: Laurent Bigonville <bigon@debian.org>
-Standards-Version: 4.1.4
-Build-Depends: debhelper (>= 10), libsepol1-dev (>= 2.8), xmlto
+Standards-Version: 4.3.0
+Build-Depends: debhelper (>= 10), libsepol1-dev (>= 2.9), xmlto
 Build-Depends-Indep: lmodern,
                      pandoc,
                      texlive-fonts-recommended,

## secilc 3.0

=== debian/changelog ===
secilc (3.0-1build1) focal; urgency=medium

  * No-change rebuild to restore i386 binaries

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 31 Dec 2019 17:46:31 -0800

secilc (3.0-1) unstable; urgency=medium

  * New upstream release
    - Bump libsepol1-dev build-dependency to >= 3.0 to match the release
    - Add texlive-latex-extra to the Build-Depends-Indep
  * debian/control: Bump Standards-Version to 4.4.1 (no further changes)
  * Bump debhelper compatibility to 12
  * Add the support for the nodoc build profile

 -- Laurent Bigonville <bigon@debian.org>  Wed, 11 Dec 2019 16:37:15 +0100

=== debian/control ===
--- 
+++ 
@@ -5,12 +5,13 @@
 Section: utils
 Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
 Uploaders: Laurent Bigonville <bigon@debian.org>
-Standards-Version: 4.3.0
-Build-Depends: debhelper (>= 10), libsepol1-dev (>= 2.9), xmlto
-Build-Depends-Indep: lmodern,
-                     pandoc,
-                     texlive-fonts-recommended,
-                     texlive-latex-recommended
+Standards-Version: 4.4.1
+Build-Depends: debhelper (>= 12), libsepol1-dev (>= 3.0), xmlto
+Build-Depends-Indep: lmodern <!nodoc>,
+                     pandoc <!nodoc>,
+                     texlive-fonts-recommended <!nodoc>,
+                     texlive-latex-extra <!nodoc>,
+                     texlive-latex-recommended <!nodoc>
 Homepage: https://github.com/SELinuxProject/selinux/wiki
 
 Package: secilc
@@ -34,6 +35,7 @@
 Architecture: all
 Depends: ${misc:Depends}
 Section: doc
+Build-Profiles: <!nodoc>
 Description: documentation for the SELinux CIL Compiler
  Security-enhanced Linux is a patch of the Linux® kernel and a number
  of utilities with enhanced security functionality designed to add

## secilc 3.1

=== Makefile ===
--- 
+++ 
@@ -13,6 +13,10 @@
 SECILC_MANPAGE = secilc.8
 SECIL2CONF_MANPAGE = secil2conf.8
 XMLTO = xmlto
+DIFF = diff
+
+CHECKPOLICY = checkpolicy
+POL_VERS = $(shell $(CHECKPOLICY) -V | cut -f 1 -d ' ')
 
 CFLAGS ?= -Wall -Wshadow -Wextra -Wundef -Wmissing-format-attribute -Wcast-align -Wstrict-prototypes -Wpointer-arith -Wunused
 
@@ -26,6 +30,9 @@
 
 test: $(SECILC)
 	./$(SECILC) test/policy.cil
+	./$(SECILC) -c $(POL_VERS) -O -M 1 -f /dev/null -o opt-actual.bin test/opt-input.cil
+	$(CHECKPOLICY) -b -C -M -o opt-actual.cil opt-actual.bin >/dev/null
+	$(DIFF) test/opt-expected.cil opt-actual.cil
 
 $(SECIL2CONF): $(SECIL2CONF_OBJS)
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)
@@ -58,6 +65,9 @@
 	rm -f file_contexts
 	rm -f $(SECILC_MANPAGE)
 	rm -f $(SECIL2CONF_MANPAGE)
+	rm -f opt-actual.cil
+	rm -f opt-actual.bin
+	$(MAKE) -C docs clean
 
 relabel:

=== docs/Makefile ===
--- 
+++ 
@@ -1,8 +1,8 @@
-CWD ?= $(shell pwd)
-HTMLDIR ?= $(CWD)/html
-PDFDIR ?= $(CWD)/pdf
-TMPDIR ?= $(CWD)/tmp
-TESTDIR ?= $(CWD)/../test
+CWD = $(shell pwd)
+HTMLDIR = $(CWD)/html
+PDFDIR = $(CWD)/pdf
+TMPDIR = $(CWD)/tmp
+TESTDIR = $(CWD)/../test
 
 # All the markdown files that make up the guide:
 FILE_LIST ?= cil_introduction.md \
@@ -31,6 +31,12 @@
 PDF_OUT=CIL_Reference_Guide.pdf
 HTML_OUT=CIL_Reference_Guide.html
 PANDOC = pandoc
+SED ?= sed
+
+OS := $(shell uname)
+ifeq ($(OS), Darwin)
+	SED := gsed
+endif
 
 all: html pdf
 
@@ -40,12 +46,12 @@
 $(TMPDIR)/%.md: %.md | $(TMPDIR)
 	cp -f $< $(TMPDIR)/
 	@# Substitute markdown links for conversion into PDF links
-	sed -i -re 's:(\[`[^`]*`\])\([^#]*([^\)]):\1\(\2:g' $@
+	$(SED) -i -re 's:(\[`[^`]*`\])\([^#]*([^\)]):\1\(\2:g' $@
 
 $(TMPDIR)/policy.cil: $(TESTDIR)/policy.cil
 	cp -f $< $@
 	@# add a title for the TOC to policy.cil. This is needed to play nicely with the PDF conversion.
-	sed -i '1i Example Policy\n=========\n```' $@
+	$(SED) -i '1i Example Policy\n=========\n```' $@
 	echo '```' >> $@
 
 html: $(PANDOC_FILE_LIST) $(TMPDIR)/policy.cil

=== debian/changelog ===
secilc (3.1-1) unstable; urgency=medium

  * New upstream release
    - Bump libsepol1-dev build-dependency to >= 3.1 to match the release
  * debian/control: Set Rules-Requires-Root: no
  * debian/control: Add checkpolicy to the BD, this is required for the tests
  * debian/control: Bump Standards-Version to 4.5.0 (no further changes)
  * Add debian/gitlab-ci.yml file

 -- Laurent Bigonville <bigon@debian.org>  Wed, 15 Jul 2020 09:07:36 +0200

=== debian/control ===
--- 
+++ 
@@ -5,14 +5,18 @@
 Section: utils
 Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
 Uploaders: Laurent Bigonville <bigon@debian.org>
-Standards-Version: 4.4.1
-Build-Depends: debhelper (>= 12), libsepol1-dev (>= 3.0), xmlto
+Standards-Version: 4.5.0
+Build-Depends: checkpolicy (>= 3.1) <!nocheck>,
+               debhelper (>= 12),
+               libsepol1-dev (>= 3.1),
+               xmlto
 Build-Depends-Indep: lmodern <!nodoc>,
                      pandoc <!nodoc>,
                      texlive-fonts-recommended <!nodoc>,
                      texlive-latex-extra <!nodoc>,
                      texlive-latex-recommended <!nodoc>
 Homepage: https://github.com/SELinuxProject/selinux/wiki
+Rules-Requires-Root: no
 
 Package: secilc
 Architecture: linux-any

=== debian/rules ===
--- 
+++ 
@@ -14,4 +14,6 @@
 	dh $@
 
 override_dh_auto_build-indep:
+ifeq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
 	$(MAKE) doc
+endif

=== debian/watch ===
version=4

opts="uversionmangle=s/-(rc)/~$1/" \
https://github.com/SELinuxProject/selinux/wiki/Releases (?:.*)/releases/download/(?:\d*)/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@

## secilc 3.3

=== debian/changelog ===
secilc (3.3-1) unstable; urgency=medium

  [ Christian Göttsche ]
  * d/gitlab-ci.yml: Use Debian recipe
  * d/control: Bump debhelper compat to level 13
  * d/control: Bump Standards-Version to 4.5.1 (no further changes)
  * d/rules: Enable build hardening
  * d/rules: Enable -Wall and -Wextra
  * d/control: Convert cute fields
  * d/gitlab-ci.yml: Disable reprotest

  [ Laurent Bigonville ]
  * debian/watch: Update the regex (again)
  * New upstream version 3.3
    - Bump the build-dependencies to >= 3.3 to match the release
  * debian/control: Bump Standards-Version to 4.6.0 (no further changes)

 -- Laurent Bigonville <bigon@debian.org>  Sun, 07 Nov 2021 23:59:56 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: secilc
-VCS-Git: https://salsa.debian.org/selinux-team/secilc.git
-VCS-Browser: https://salsa.debian.org/selinux-team/secilc
+Vcs-Git: https://salsa.debian.org/selinux-team/secilc.git
+Vcs-Browser: https://salsa.debian.org/selinux-team/secilc
 Priority: optional
 Section: utils
 Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
 Uploaders: Laurent Bigonville <bigon@debian.org>
-Standards-Version: 4.5.0
-Build-Depends: checkpolicy (>= 3.1) <!nocheck>,
-               debhelper (>= 12),
-               libsepol1-dev (>= 3.1),
+Standards-Version: 4.6.0
+Build-Depends: checkpolicy (>= 3.3) <!nocheck>,
+               debhelper-compat (= 13),
+               libsepol-dev (>= 3.3),
                xmlto
 Build-Depends-Indep: lmodern <!nodoc>,
                      pandoc <!nodoc>,

## secilc 3.4

=== Makefile ===
--- 
+++ 
@@ -10,8 +10,13 @@
 SECIL2CONF_SRCS := secil2conf.c
 SECIL2CONF_OBJS := $(patsubst %.c,%.o,$(SECIL2CONF_SRCS))
 
+SECIL2TREE = secil2tree
+SECIL2TREE_SRCS := secil2tree.c
+SECIL2TREE_OBJS := $(patsubst %.c,%.o,$(SECIL2TREE_SRCS))
+
 SECILC_MANPAGE = secilc.8
 SECIL2CONF_MANPAGE = secil2conf.8
+SECIL2TREE_MANPAGE = secil2tree.8
 XMLTO = xmlto
 DIFF = diff
 
@@ -23,7 +28,7 @@
 override CFLAGS += -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64
 override LDLIBS += -lsepol
 
-all: $(SECILC) $(SECIL2CONF) man
+all: $(SECILC) $(SECIL2CONF) $(SECIL2TREE) man
 
 $(SECILC): $(SECILC_OBJS)
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)
@@ -37,7 +42,10 @@
 $(SECIL2CONF): $(SECIL2CONF_OBJS)
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)
 
-man: $(SECILC_MANPAGE) $(SECIL2CONF_MANPAGE)
+$(SECIL2TREE): $(SECIL2TREE_OBJS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)
+
+man: $(SECILC_MANPAGE) $(SECIL2CONF_MANPAGE) $(SECIL2TREE_MANPAGE)
 
 $(SECILC_MANPAGE): $(SECILC_MANPAGE).xml
 	$(XMLTO) man $(SECILC_MANPAGE).xml
@@ -45,13 +53,18 @@
 $(SECIL2CONF_MANPAGE): $(SECIL2CONF_MANPAGE).xml
 	$(XMLTO) man $(SECIL2CONF_MANPAGE).xml
 
+$(SECIL2TREE_MANPAGE): $(SECIL2TREE_MANPAGE).xml
+	$(XMLTO) man $(SECIL2TREE_MANPAGE).xml
+
 install: all man
 	-mkdir -p $(DESTDIR)$(BINDIR)
 	-mkdir -p $(DESTDIR)$(MANDIR)/man8
 	install -m 755 $(SECILC) $(DESTDIR)$(BINDIR)
 	install -m 755 $(SECIL2CONF) $(DESTDIR)$(BINDIR)
+	install -m 755 $(SECIL2TREE) $(DESTDIR)$(BINDIR)
 	install -m 644 $(SECILC_MANPAGE) $(DESTDIR)$(MANDIR)/man8
 	install -m 644 $(SECIL2CONF_MANPAGE) $(DESTDIR)$(MANDIR)/man8
+	install -m 644 $(SECIL2TREE_MANPAGE) $(DESTDIR)$(MANDIR)/man8
 
 doc:
 	$(MAKE) -C docs
@@ -61,10 +74,13 @@
 	rm -f $(SECILC_OBJS)
 	rm -f $(SECIL2CONF)
 	rm -f $(SECIL2CONF_OBJS)
+	rm -f $(SECIL2TREE)
+	rm -f $(SECIL2TREE_OBJS)
 	rm -f policy.*
 	rm -f file_contexts
 	rm -f $(SECILC_MANPAGE)
 	rm -f $(SECIL2CONF_MANPAGE)
+	rm -f $(SECIL2TREE_MANPAGE)
 	rm -f opt-actual.cil
 	rm -f opt-actual.bin
 	$(MAKE) -C docs clean

=== debian/changelog ===
secilc (3.4-1) unstable; urgency=medium

  * New upstream release
    - Bump the build-dependencies to >= 3.4 to match the release
  * Enable GPG key validation of the upstream tarball
  * debian/control: Mark secilc-doc as Multi-Arch: foreign

 -- Laurent Bigonville <bigon@debian.org>  Sat, 04 Jun 2022 14:04:14 +0200

=== debian/control ===
--- 
+++ 
@@ -6,9 +6,9 @@
 Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
 Uploaders: Laurent Bigonville <bigon@debian.org>
 Standards-Version: 4.6.0
-Build-Depends: checkpolicy (>= 3.3) <!nocheck>,
+Build-Depends: checkpolicy (>= 3.4) <!nocheck>,
                debhelper-compat (= 13),
-               libsepol-dev (>= 3.3),
+               libsepol-dev (>= 3.4),
                xmlto
 Build-Depends-Indep: lmodern <!nodoc>,
                      pandoc <!nodoc>,
@@ -40,6 +40,7 @@
 Depends: ${misc:Depends}
 Section: doc
 Build-Profiles: <!nodoc>
+Multi-Arch: foreign
 Description: documentation for the SELinux CIL Compiler
  Security-enhanced Linux is a patch of the Linux® kernel and a number
  of utilities with enhanced security functionality designed to add

## secilc 3.5

=== debian/changelog ===
secilc (3.5-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Repository-Browse.
  * Update standards version to 4.6.2, no changes needed.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository.

  [ Laurent Bigonville ]
  * New upstream release
    - Bump the build-dependencies to >= 3.5 to match the release
  * debian/upstream/signing-key.asc: Add public key of Jason Zaman

 -- Laurent Bigonville <bigon@debian.org>  Mon, 10 Jul 2023 20:59:07 +0200

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Section: utils
 Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
 Uploaders: Laurent Bigonville <bigon@debian.org>
-Standards-Version: 4.6.0
-Build-Depends: checkpolicy (>= 3.4) <!nocheck>,
+Standards-Version: 4.6.2
+Build-Depends: checkpolicy (>= 3.5) <!nocheck>,
                debhelper-compat (= 13),
-               libsepol-dev (>= 3.4),
+               libsepol-dev (>= 3.5),
                xmlto
 Build-Depends-Indep: lmodern <!nodoc>,
                      pandoc <!nodoc>,

## secilc 3.7

=== debian/changelog ===
secilc (3.7-1) unstable; urgency=medium

  * New upstream release

 -- Russell Coker <russell@coker.com.au>  Fri, 23 Aug 2024 19:29:50 +1000

=== debian/control ===
--- 
+++ 
@@ -6,9 +6,9 @@
 Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
 Uploaders: Laurent Bigonville <bigon@debian.org>
 Standards-Version: 4.6.2
-Build-Depends: checkpolicy (>= 3.5) <!nocheck>,
+Build-Depends: checkpolicy (>= 3.7) <!nocheck>,
                debhelper-compat (= 13),
-               libsepol-dev (>= 3.5),
+               libsepol-dev (>= 3.7),
                xmlto
 Build-Depends-Indep: lmodern <!nodoc>,
                      pandoc <!nodoc>,

## secilc 3.8

=== debian/changelog ===
secilc (3.8-1) unstable; urgency=medium

  * 3.8 release

 -- Russell Coker <russell@coker.com.au>  Thu, 06 Feb 2025 22:40:24 +1100

=== debian/control ===
--- 
+++ 
@@ -6,9 +6,9 @@
 Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
 Uploaders: Laurent Bigonville <bigon@debian.org>
 Standards-Version: 4.6.2
-Build-Depends: checkpolicy (>= 3.7) <!nocheck>,
+Build-Depends: checkpolicy (>= 3.8) <!nocheck>,
                debhelper-compat (= 13),
-               libsepol-dev (>= 3.7),
+               libsepol-dev (>= 3.8),
                xmlto
 Build-Depends-Indep: lmodern <!nodoc>,
                      pandoc <!nodoc>,

## secilc 3.8.1

=== debian/changelog ===
secilc (3.8.1-1) unstable; urgency=medium

  * New upstream release, only version number change

 -- Russell Coker <russell@coker.com.au>  Sun, 16 Mar 2025 18:29:22 +1100

=== debian/control ===
--- 
+++ 
@@ -6,9 +6,9 @@
 Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
 Uploaders: Laurent Bigonville <bigon@debian.org>
 Standards-Version: 4.6.2
-Build-Depends: checkpolicy (>= 3.8) <!nocheck>,
+Build-Depends: checkpolicy (>= 3.8.1) <!nocheck>,
                debhelper-compat (= 13),
-               libsepol-dev (>= 3.8),
+               libsepol-dev (>= 3.8.1),
                xmlto
 Build-Depends-Indep: lmodern <!nodoc>,
                      pandoc <!nodoc>,

## secilc 3.9

=== Makefile ===
--- 
+++ 
@@ -31,7 +31,7 @@
 all: $(SECILC) $(SECIL2CONF) $(SECIL2TREE) man
 
 $(SECILC): $(SECILC_OBJS)
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)
 
 test: $(SECILC)
 	./$(SECILC) test/policy.cil
@@ -40,10 +40,10 @@
 	$(DIFF) test/opt-expected.cil opt-actual.cil
 
 $(SECIL2CONF): $(SECIL2CONF_OBJS)
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)
 
 $(SECIL2TREE): $(SECIL2TREE_OBJS)
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LDLIBS)
 
 man: $(SECILC_MANPAGE) $(SECIL2CONF_MANPAGE) $(SECIL2TREE_MANPAGE)

=== debian/changelog ===
secilc (3.9-1) unstable; urgency=medium

  * New upstream release
  * Fix to building with GNUMAKEFLAGS=--shuffle=reverse Closes: #1105662

 -- Russell Coker <russell@coker.com.au>  Sat, 18 Oct 2025 18:20:43 +1100

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,11 @@
 Priority: optional
 Section: utils
 Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
-Uploaders: Laurent Bigonville <bigon@debian.org>
+Uploaders: Russell Coker <russell@coker.com.au>
 Standards-Version: 4.6.2
-Build-Depends: checkpolicy (>= 3.8.1) <!nocheck>,
+Build-Depends: checkpolicy (>= 3.9) <!nocheck>,
                debhelper-compat (= 13),
-               libsepol-dev (>= 3.8.1),
+               libsepol-dev (>= 3.9),
                xmlto
 Build-Depends-Indep: lmodern <!nodoc>,
                      pandoc <!nodoc>,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# The build system doesn't use CPPFLAGS, pass them to CFLAGS to enable the
# missing (hardening) flags. Also enable Wall and Wextra to spot basic irregularities.
export DEB_CFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS) -Wall -Wextra

%:
	dh $@

override_dh_auto_build-indep:
ifeq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
	$(MAKE) doc
endif
